#how to run: behave -D password=your_password -D containers='comma seperated list of containers(if want to run the feature file for RHOSP13 onwords)' features/netstorage_certification/neutron_5x.feature

Feature: Cinder Certification

  @rhcert_4x
  Scenario: Login to RHCert
    Given  I go to RHCERT login page
    When   I fill in the rhcert login credential
    And    I click the Login button
    Then   I should be logged into RHCERT

   @rhcert_4x
  Scenario: Add a SUT to run the tests
    Given I am logged into RHCERT
    When  I go to the configuration tab
    And   I add a "cinder" SUT
    Then  The "cinder" SUT should be registered successfully

  @rhcert_4x
  Scenario: Create Certification for Cinder
    Given I am logged into RHCERT
    When  I click on the New Certification button
    And   I select product "Red Hat OpenStack Platform"
    And   I select RHOS version "12.0"
    And   I select platform "x86_64"
    And   I select RHEL version "7.4"
    And   I click on Next button
    And   I select vendor "viksss_stage (1165)"
    And   I select openstack product name "openstack: viksss_stage_product (3618043)"
    And   I click on Next button
    And   I enter product version "RHOSP13"
    And   I select openstack plugin name "certification-blockstorage-plugin"
    And   I enter "https:example.com" as a source url
    And   I enter "https:example.com" as a blueprint url
    And   I enter "Test" as a install guide
    And   I enter "Test" as a user guide
    And   I enter "Test" as a configuration
    And   I enter "Red Hat" as a hostname
    And   I enter "yes" for apps on rhel
    And   I enter "yes" for apps on RHOSP
    And   I enter "yes" for additional kernel drivers
    And   I enter "test hardware" for special hardware requirement
    And   I click on Next button
    And   I select protocol "Select All" for cinder
    And   I click on create button
    And   I could see the "cinder" certification created on rhcert

  Scenario: Validate certification details
    Given Open "cinder" certification
    When  I click on Details button
    Then  I validate the data which I have entered while cert creation

  Scenario: Adding comment and validating
    Given Open "cinder" certification
    When  I click on dialog tab
    And   I add "viksss" as a comment
    And   I click on Add comment
    Then  I see comment "viksss" is added

  Scenario: Adding Attachment and validating
    Given Open "cinder" certification
    When  I click on dialog tab
    And   I add attachment "/home/vikasmulaje/Documents/boyz.pdf" and description "viksss"
    And   I click on upload
    Then  I see attachment uploaded

  Scenario: Selecting Sut and test selection with result submission
    Given Open "cinder" certification
    When  I click on Testing tab
    And   I click on Add Test System
    And   I select the SUT "cinder"
    And   I click on test button
    And   I click on continue testing
    And   I select feature tests for "cinder_all"
    And   I select feature tests for "tempest_config"
    And   I click on run test
    And   Fill details for tempest config
    And   I wait for test run to complete
    And   I click on "cinder" result link
    And   I click on submit test
    And   I click on submit
    Then  I should see result is submitted

  Scenario: Validate result parsing
    Given Open "cinder" certification
    When   I click on Dialog tab
    Then   I check result is submited sucessfully

  @rhcert_4x @rhcert_5x
  Scenario: logs validation
    Given I logged into the SUT for "cinder" log validation
    When  I wget the script for "cinder"
    Then  I validate the logs for "cinder"
