Feature: Management Functionality For OpenStack

  @rhcert_cli
  Scenario: Clean and Verify RHCERT system
    Given I have sshed into RHCERT
    And   'redhat-certification' package is installed on 'rhcert'
    And   'redhat-certification-backend' package is installed on 'rhcert'
    When  "httpd" service is "running" on "rhcert"
    And   "firewalld" service is "inactive" on "rhcert"
    And   I stop the rhcertd service
    And   I clean the RHCERT system
    And   I start the rhcertd service
    Then  I close the RHCERT ssh connection

   @rhcert_cli
  Scenario: Configure a management system
    Given  I have sshed into RHCERT
    When   I configure the machine to 'management'
    And    I verify machine is configured to 'management'
    Then   I close the RHCERT ssh connection

  Scenario: Create certification for cinder
    Given I am logged into RHCERT in Management mode
    When  I click on the New Certification button
    And   I select product "Red Hat OpenStack Platform"
    And   I select RHOS version "12.0"
    And   I select platform "x86_64"
    And   I select RHEL version "7.4"
    And   I click on Next button
    And   I select vendor "Viksss_March (877)"
    And   I select openstack product name "openstack: viksss_march_product (3355263)"
    And   I click on Next button
    And   I enter product version "RHOSP11"
    And   I select openstack plugin name "certification-blockstorage-plugin"
    And   I enter "https:example.com" as a source url
    And   I enter "https:example.com" as a blueprint url
    And   I enter "Test" as a install guide
    And   I enter "Test" as a user guide
    And   I enter "Test" as a configuration
    And   I enter "Red Hat" as a hostname
    And   I enter "yes" for apps on rhel
    And   I enter "yes" for apps on RHOSP
    And   I enter "yes" for additional kernel drivers
    And   I enter "test hardware" for special hardware requirement
    And   I click on Next button
    And   I select protocol "other" for cinder
    And   I click on create button
    And   I could see the "cinder" certification created on rhcert
    And   I click on Details button
    And   I validate the data which I have entered while cert creation
    And   I click on dialog tab
    And   I add "viksss" as a comment
    And   I click on Add comment
    And   I see comment "viksss" is added
    And   I add attachment "/home/vikasmulaje/Documents/boyz.pdf" and description "viksss"
    And   I click on upload
    Then  I see attachment uploaded

  Scenario: Create certification for neutron
    Given I am logged into RHCERT in Management mode
    When  I click on the New Certification button
    And   I select product "Red Hat OpenStack Platform"
    And   I select RHOS version "11.0"
    And   I select platform "x86_64"
    And   I select RHEL version "7.2"
    And   I click on Next button
    And   I select vendor "Abbee (412)"
    And   I select openstack product name "openstack: viksss_qa_oct (3241933)"
    And   I click on Next button
    And   I enter product version "RHOSP11"
    And   I select openstack plugin name "certification-networking-plugin"
    And   I enter "https:example.com" as a source url
    And   I enter "https:example.com" as a blueprint url
    And   I enter "Test" as a install guide
    And   I enter "Test" as a user guide
    And   I enter "Test" as a configuration
    And   I enter "Red Hat" as a hostname
    And   I enter "yes" for apps on rhel
    And   I enter "yes" for apps on RHOSP
    And   I enter "yes" for additional kernel drivers
    And   I enter "test hardware" for special hardware requirement
    And   I click on Next button
    And   I select type of plugin "ml2"
    And   I click on create button
    And   I could see the "neutron" certification created on rhcert
    And   I click on Details button
    And   I validate the data which I have entered while cert creation
    And   I click on dialog tab
    And   I add "viksss" as a comment
    And   I click on Add comment
    And   I see comment "viksss" is added
    And   I add attachment "/home/vikasmulaje/Documents/boyz.pdf" and description "viksss"
    And   I click on upload
    Then  I see attachment uploaded

  Scenario: Create certification for manila
    Given I am logged into RHCERT in Management mode
    When  I click on the New Certification button
    And   I select product "Red Hat OpenStack Platform"
    And   I select RHOS version "12.0"
    And   I select platform "x86_64"
    And   I select RHEL version "7.5"
    And   I click on Next button
    And   I select vendor "Abbee (412)"
    And   I select openstack product name "openstack: viksss_qa_oct (3241933)"
    And   I click on Next button
    And   I enter product version "RHOSP11"
    And   I select openstack plugin name "certification-filestorage-plugin"
    And   I enter "https:example.com" as a source url
    And   I enter "https:example.com" as a blueprint url
    And   I enter "Test" as a install guide
    And   I enter "Test" as a user guide
    And   I enter "Test" as a configuration
    And   I enter "Red Hat" as a hostname
    And   I enter "yes" for apps on rhel
    And   I enter "yes" for apps on RHOSP
    And   I enter "yes" for additional kernel drivers
    And   I enter "test hardware" for special hardware requirement
    And   I click on Next button
    And   I select protocol "other" for manila
    And   I click on create button
    And   I could see the "manila" certification created on rhcert
    And   I click on Details button
    And   I validate the data which I have entered while cert creation
    And   I click on dialog tab
    And   I add "viksss" as a comment
    And   I click on Add comment
    And   I see comment "viksss" is added
    And   I add attachment "/home/vikasmulaje/Documents/boyz.pdf" and description "viksss"
    And   I click on upload
    Then  I see attachment uploaded

  Scenario: Create certification for other
    Given I am logged into RHCERT in Management mode
    When  I click on the New Certification button
    And   I select product "Red Hat OpenStack Platform"
    And   I select RHOS version "11.0"
    And   I select platform "x86_64"
    And   I select RHEL version "7.4"
    And   I click on Next button
    And   I select vendor "Abbee (317)"
    And   I select openstack product name "openstack: Anand_nov_stage (2931193)"
    And   I click on Next button
    And   I enter product version "RHOSP11"
    And   I select openstack plugin name "certification-other-application"
    And   I enter "https:example.com" as a source url
    And   I enter "https:example.com" as a blueprint url
    And   I enter "Test" as a install guide
    And   I enter "Test" as a user guide
    And   I enter "Test" as a configuration
    And   I enter "Red Hat" as a hostname
    And   I enter "yes" for apps on rhel
    And   I enter "yes" for apps on RHOSP
    And   I enter "yes" for additional kernel drivers
    And   I enter "test hardware" for special hardware requirement
    And   I click on create button
    And   I could see the "other" certification created on rhcert
    And   I click on Details button
    And   I validate the data which I have entered while cert creation
    And   I click on dialog tab
    And   I add "viksss" as a comment
    And   I click on Add comment
    And   I see comment "viksss" is added
    And   I add attachment "/home/vikasmulaje/Documents/boyz.pdf" and description "viksss"
    And   I click on upload
    Then  I see attachment uploaded

  Scenario: Create Certification for VNF
    Given I am logged into RHCERT in Management mode
    When  I click on the New Certification button
    And   I select product "Red Hat OpenStack Platform"
    And   I select RHOS version "12.0"
    And   I select platform "x86_64"
    And   I select RHEL version "7.4"
    And   I click on Next button
    And   I select vendor "Viksss_March_stage (997)"
    And   I select openstack product name "openstack: Viksss_March_stage_Product (3358223)"
    And   I click on Next button
    And   I enter product version "RHOSP12"
    And   I select openstack plugin name "certification-vnf-component"
    And   I enter "https:example.com" as a source url
    And   I enter "https:example.com" as a blueprint url
    And   I enter "Test" as a install guide
    And   I enter "Test" as a user guide
    And   I enter "Test" as a configuration
    And   I enter "Red Hat" as a hostname
    And   I enter "yes" for apps on rhel
    And   I enter "yes" for apps on RHOSP
    And   I enter "yes" for additional kernel drivers
    And   I enter "test hardware" for special hardware requirement
    And   I click on Next button
    And   I select "rhel_modified" for VNF virtual machine
    And   I upload vnf configuration "/home/vikasmulaje/Documents/boyz.pdf"
    And   I click on create button
    And   I could see the "VNF" certification created on rhcert
    And   I click on Details button
    And   I validate the data which I have entered while cert creation
    And   I click on dialog tab
    And   I add "viksss" as a comment
    And   I click on Add comment
    And   I see comment "viksss" is added
    And   I add attachment "/home/vikasmulaje/Documents/boyz.pdf" and description "viksss"

  @rhcert_cli
  Scenario: Configure machine back to deafult
    Given  I have sshed into RHCERT
    When   I configure the machine to 'default'
    And    I verify machine is configured to 'dafault'
    And    I stop the rhcertd service
    And    I start the rhcertd service
    Then   I close the RHCERT ssh connection
