#how to run: behave -D password=your_password features/netstorage_certification/manila_5x.feature
Feature: Manila Certification

  @rhcert_4x
  Scenario: Login to RHCert
    Given  I go to RHCERT login page
    When   I fill in the rhcert login credential
    And    I click the Login button
    Then   I should be logged into RHCERT

  @rhcert_4x
  Scenario: Add a SUT to run the tests
    Given I am logged into RHCERT
    When  I go to the configuration tab
    And   I add a "manila" SUT
    Then  The "manila" SUT should be registered successfully

  @rhcert_4x
  Scenario: Create Certification for Manila And Run The Test
    Given I am logged into RHCERT
    When  I click on the New Certification button
    And   I select product "Red Hat OpenStack Platform"
    And   I select RHOS version "11.0"
    And   I select platform "x86_64"
    And   I select RHEL version "7.2"
    And   I click on Next button
    And   I select vendor "Abbee (412)"
    And   I select openstack product name "openstack: viksss_qa_oct (3241933)"
    And   I click on Next button
    And   I enter product version "RHOSP13"
    And   I select openstack plugin name "certification-filestorage-plugin"
    And   I enter "https:example.com" as a source url
    And   I enter "https:example.com" as a blueprint url
    And   I enter "Test" as a install guide
    And   I enter "Test" as a user guide
    And   I enter "Test" as a configuration
    And   I enter "Red Hat" as a hostname
    And   I enter "yes" for apps on rhel
    And   I enter "yes" for apps on RHOSP
    And   I enter "yes" for additional kernel drivers
    And   I enter "test hardware" for special hardware requirement
    And   I click on Next button
    And   I select protocol "Select All" for manila
    And   I click on create button
    And   I could see the "manila" certification created on rhcert
    And   I click on Details button
    And   I validate the data which I have entered while cert creation
    And   I click on dialog tab
    And   I add "viksss" as a comment
    And   I click on Add comment
    And   I see comment "viksss" is added
    And   I add attachment "/home/vikasmulaje/Documents/boyz.pdf" and description "viksss"
    And   I click on upload
    And   I see attachment uploaded
    And   I click on Testing tab
    And   I click on Add Test System
    And   I select the SUT "manila"
    And   I click on test button
    And   I click on continue testing
    And   I select feature tests for "manila_all"
    And   I select feature tests for "tempest_config"
    And   I click on run test
    And   Fill details for tempest config
    And   I wait for test run to complete
    And   I click on "manila" result link
    And   I click on submit test
    And   I click on submit
    Then  I should see result is submitted
    And   I click on Dialog tab
    And   I check result is submited sucessfully
  @rhcert_4x @rhcert_5x
  Scenario: logs validation
    Given I logged into the SUT for "manila" log validation
    When  I wget the script for "manila"
    Then  I validate the logs for "manila"
