Feature: VNF Certification

  @rhcert_4x
  Scenario: Login to RHCert
    Given  I go to RHCERT login page
    When   I fill in the rhcert login credential
    And    I click the Login button
    Then   I should be logged into RHCERT

   @rhcert_4x
  Scenario: Add a SUT to run the tests
    Given I am logged into RHCERT
    When  I go to the configuration tab
    And   I add a "VNF" SUT
    Then  The "VNF" SUT should be registered successfully

  @rhcert_4x
  Scenario: Create Certification for VNF And Run The Test
    Given I am logged into RHCERT
    When  I click on the New Certification button
    And   I select product "Red Hat OpenStack Platform"
    And   I select RHOS version "12.0"
    And   I select platform "x86_64"
    And   I select RHEL version "7.4"
    And   I click on Next button
    And   I select vendor "Viksss_March_stage (997)"
    And   I select openstack product name "openstack: Viksss_March_stage_Product (3358223)"
    And   I click on Next button
    And   I enter product version "RHOSP12"
    And   I select openstack plugin name "certification-vnf-component"
    And   I enter "https:example.com" as a source url
    And   I enter "https:example.com" as a blueprint url
    And   I enter "Test" as a install guide
    And   I enter "Test" as a user guide
    And   I enter "Test" as a configuration
    And   I enter "Red Hat" as a hostname
    And   I enter "yes" for apps on rhel
    And   I enter "yes" for apps on RHOSP
    And   I enter "yes" for additional kernel drivers
    And   I enter "test hardware" for special hardware requirement
    And   I click on Next button
    And   I select "rhel_modified" for VNF virtual machine
    And   I upload vnf configuration "/home/vikasmulaje/Documents/boyz.pdf"
    And   I click on create button
    And   I could see the "VNF" certification created on rhcert
    And   I click on Details button
    And   I validate the data which I have entered while cert creation
    And   I click on dialog tab
    And   I add "viksss" as a comment
    And   I click on Add comment
    And   I see comment "viksss" is added
    And   I add attachment "/home/vikasmulaje/Documents/boyz.pdf" and description "viksss"
    And   I click on upload
    And   I see attachment uploaded
    And   I click on Testing tab
    And   I click on Add Test System
    And   I select the SUT "VNF"
    And   I click on test button
    And   I click on continue testing
    And   I click on run test
    And   I wait for test run to complete
    And   I click on "VNF" result link
    And   I click on submit test
    And   I click on submit
    Then  I should see result is submitted
