Feature: Cloud Certification

  @rhcert_4x
  Scenario: Login to Rhcert
    Given I go to RHCERT login page
    When  I fill in the rhcert login credential
    And   I click the Login button
    Then  I should be logged into RHCERT

  @rhcert_4x
  Scenario: Create certification against a New Product on rhcert
    Given I am logged into RHCERT
    When  I click on the New Certification button
    When  I select product "Red Hat Enterprise Linux"
    And   I select RHEL version "7.3" for cloud
    And   I select platform "x86_64"
    And   I click on Next button
    And   I click on New Product
    And   I select vendor "Abbee (ID: 390)" for product creation
    And   I select Program "Red Hat Certified Cloud Service Provider"
    And   I click on Next button
    And   I input Cloud/Service Name
    And   I input Public Catalog URL "http://cloud.com"
    And   I select Supported Regions
    And   I input Supported Languages "English"
    And   I input 3rd Party Certification "IBM"
    And   I click on Next button
    Then  I see the "cloud" product created on rhcert
    Then  I see the "cloud" certification created on rhcert against new Product
    And   I click on Details button
    And   I save the cert_nid of "cloud" created on rhcert

  @rhcert_4x
  Scenario: Add a SUT to run the tests
    Given I am logged into RHCERT
    When  I go to the configuration tab
    And   I add a "cloud" SUT
    Then  The "cloud" SUT should be registered successfully

  @rhcert_4x
  Scenario: Select a SUT to run all tests on
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on Testing tab
    And   I click on Add System button
    And   I check for override button
    And   I select the radio button for "cloud" SUT
    And   I click on Test button
    And   I wait for a while for test verification
    And   I click on the Continue Testing button
    And   I select tests for cloud cert
    And   I click on the Run Selected Button
    And   I give reason for supportable test checks
    And   I give reason for configuration test checks
    And   I wait for a while for the "cloud" tests to run
    And   I click the "cloud" result link
    And   I submit the result
    Then  I can see the "cloud" result is submitted

