Feature: Cloud Certification
  @rhcert_cli
  Scenario: Clean and Verify RHCERT system
    Given I have sshed into RHCERT
    And   'redhat-certification' package is installed on 'rhcert'
    And   'redhat-certification-backend' package is installed on 'rhcert'
    When  "httpd" service is "running" on "rhcert"
    And   "firewalld" service is "inactive" on "rhcert"
    And   I stop the rhcertd service
    And   I clean the RHCERT system
    And   I start the rhcertd service
    Then   I close the RHCERT ssh connection
  
  @rhcert_4x
  Scenario: Login to Rhcert
    Given I go to RHCERT login page
    When  I fill in the rhcert login credential
    And   I click the Login button
    Then  I should be logged into RHCERT
  
  @rhcert_4x
  Scenario: Add a SUT to run the tests
    Given I am logged into RHCERT
    When  I go to the configuration tab
    And   I add a "cloud" SUT
    Then  The "cloud" SUT should be registered successfully
    And   I check "cloud" sut info and save it
  
  @rhcert_4x
  Scenario: Refresh Button Functionality
    Given I am logged into RHCERT
    When  I check for Refresh Button
    Then  I can see the Refresh Button
  @rhcert_4x
  Scenario: Select a SUT to run all Mandatory tests
    Given I have "cloud" cert for "Abbee (1027)" "cloud: rhcert-5.16 Release Test Prosuct (3566613)"
    When  I click on Testing tab
    And   I click on Add System button
    And   I check for override button
    And   I select the radio button for "cloud" SUT
    And   I click on Test button
    And   I wait for a while for test verification
    And   I click on the Continue Testing button
    And   I click on the Run Selected Button
    And   I give reason for supportable test checks
    And   I wait for a while for the "cloud" tests to run
    And   I click the "cloud" result link
    And   I submit the result
    Then  I can see the "cloud" result is submitted
  
  @rhcert_4x
  Scenario: Create cert against existing product
    Given I am logged into RHCERT
    When  I click on the New Certification button
    When  I select product "Red Hat Enterprise Linux"
    And   I select RHEL version of "cloud" SUT
    And   I select platform of "cloud" SUT
    And   I click on Next button
    And   I select vendor "Abbee (1027)"
    And   I select Make "All"
    And   I select Name "cloud: Test Image for Cloud - 20th June 2018 - QA - Suprith (3507393)"
    And   I click on Next button
    Then  I see the "cloud" certification created on rhcert

  @rhcert_4x
  Scenario: Select a SUT to run all tests on
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on Testing tab
    And   I click on Add System button
    And   I check for override button
    And   I select the radio button for "cloud" SUT
    And   I click on Test button
    And   I wait for a while for test verification
    And   I click on the Continue Testing button
    And   I select tests for cloud cert
    And   I click on the Run Selected Button
    And   I give reason for configuration test checks
    And   I give reason for supportable test checks
    And   I wait for a while for the "cloud" tests to run
    And   I click the "cloud" result link
    And   I submit the result
    Then  I can see the "cloud" result is submitted

  @rhcert_4x
  Scenario: Upload result for existing certification
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on upload result button
    And   I enter result file for uploading
    And   I click on upload button
    And   I click on confirm button
    And   I click on confirm_submission button
    Then  I see result file is submitted

  @rhcert_4x
  Scenario: Download Submitted Results to SUT
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on Download Button in the Submitted Test Results table
    Then  The Results File is downloaded

  @rhcert_5x
  Scenario: Test comments in Dialog tab
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on dialog tab
    And   I add "test comment for cloud" as a comment
    And   I click on Add Comment
    Then  I see comment "test comment for cloud" is added

  @rhcert_5x @rhcert_4x
  Scenario: Upload Attachment and Add Attachment Desciption in Dialog Tab
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on dialog tab
    And   I add an attachment
    And   I add description "Test Description" for the attachment
    And   I click on upload
    Then  I see attachment is successfully uploaded

  @rhcert_5x @rhcert_4x
  Scenario: Update Product Details
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on Product tab
    And   I click on Product Details tab
    And   I select Supported Regions
    And   I enter "English, Japanese" in supported languages
    And   I enter "3rd Party Certifications" in 3rd Party Certifications
    And   I click on save button on product details page
    Then  I can see details updated

  @rhcert_4x
  Scenario: Add Support Case ID to existing Certification
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on Details button
    And   I enter "01846543" Support Case ID
    And   I click on update button to update certification details
    Then  I can see the Certification details updated

  @rhcert_4x
  Scenario: Add KBase Reference ID to existing Certification
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on Details button
    And   I select "Red Hat Knowledge Base (Solution)" type
    And   I enter "3003271" KBase Reference ID
    And   I click on update button to update certification details
    Then  I can see the Certification details updated
