Feature: Cloud Certification CI

  @rhcert_cli
  Scenario: Clean and Verify RHCERT system
    Given I have sshed into RHCERT
    And   'redhat-certification' package is installed on 'rhcert'
    And   'redhat-certification-backend' package is installed on 'rhcert'
    When  "httpd" service is "running" on "rhcert"
    And   "firewalld" service is "inactive" on "rhcert"
    And   I stop the rhcertd service
    And   I clean the RHCERT system
    And   I start the rhcertd service
    Then   I close the RHCERT ssh connection

  @rhcert_cli
  Scenario: Check whether Packages installed on cloud SUT
    Given I have sshed into cloud SUT
    And   'redhat-certification-backend' package is installed on 'sut'
    And   'redhat-certification' package is installed on 'sut'
    And   'redhat-certification-cloud' package is installed on 'sut'
    Then   I close the SUT ssh connection

  @rhcert_4x
  Scenario: Create cert against existing product for cli submit
    Given I am logged into RHCERT
    When  I click on the New Certification button
    When  I select product "Red Hat Enterprise Linux"
    And   I select RHEL version "7.5" for "cloud"
    And   I select platform "x86_64"
    And   I click on Next button
    And   I select vendor "Abbee (1027)"
    And   I select Make "All"
    And   I select Name "cloud: rhcert-5.16 Release Test Prosuct (3566613)"
    And   I click on Next button
    Then  I see the "cloud" certification created on rhcert

  @rhcert
  Scenario: Run All Tests on cloud SUT
    Given  I have sshed into cloud SUT
    And   'redhat-certification' package is installed on 'sut'
    And   'redhat-certification-backend' package is installed on 'sut'
    And   'redhat-certification-cloud' package is installed on 'sut'
    When  "httpd" service is "running" on "sut"
    And   "firewalld" service is "inactive" on "sut"
    And   I clean the cloud SUT for rhcert-ci
    And   I plan test on cloud SUT for rhcert-ci
    And   I print the test plan on cloud SUT for rhcert-ci
    And   I run all tests on cloud SUT for rhcert-ci
    And   I save a copy of current test results for rhcert-ci
    And   I submit 'cloud' certification results to Red Hat
    Then  I close the SUT ssh connection
