Feature: Management Functionality

  @rhcert_cli
  Scenario: Clean and Verify RHCERT system
    Given I have sshed into RHCERT
    And   'redhat-certification' package is installed on 'rhcert'
    And   'redhat-certification-backend' package is installed on 'rhcert'
    When  "httpd" service is "running" on "rhcert"
    And   "firewalld" service is "inactive" on "rhcert"
    And   I stop the rhcertd service
    And   I clean the RHCERT system
    And   I start the rhcertd service
    Then  I close the RHCERT ssh connection

  @rhcert_cli
  Scenario: Check whether Packages installed on cloud SUT
    Given I have sshed into cloud SUT
    And   'redhat-certification-backend' package is installed on 'sut'
    And   'redhat-certification' package is installed on 'sut'
    And   'redhat-certification-cloud' package is installed on 'sut'
    Then   I close the SUT ssh connection

  @rhcert_cli
  Scenario: Configure a management system
    Given  I have sshed into RHCERT
    When   I configure the machine to 'management'
    And    I verify machine is configured to 'management'
    Then   I close the RHCERT ssh connection

  @rhcert_cli
  Scenario: Create a CCSP cert on Management deployment
    Given  I am logged into RHCERT in Management mode
    When   I click on the New Certification button
    And    I select product "Red Hat Enterprise Linux"
    And    I select RHEL version "7.5" for "cloud"
    And    I select platform "x86_64"
    And    I click on Next button
    And    I select vendor "Abbee (1147)"
    And    I select Make "All"
    And    I select Name "cloud: Test Image for Cloud - Suprith - QA - Test2 (3593093)"
    And    I click on Next button
    Then   I see the "cloud" certification created on rhcert

  @rhcert_cli
  Scenario: Submit results to a management cert through CLI
    Given  I have sshed into cloud SUT
    And    'redhat-certification' package is installed on 'sut'
    And    'redhat-certification-backend' package is installed on 'sut'
    And    'redhat-certification-cloud' package is installed on 'sut'
    When   I clean the cloud SUT
    And    I plan test on cloud SUT
    And    I print the test plan on cloud SUT
    And    I run all tests on cloud SUT
    And    I submit 'cloud' certification results to Red Hat
    Then   I close the SUT ssh connection

  @rhcert_4x
  Scenario: Upload result for existing certification
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on upload result button
    And   I enter result file for uploading
    And   I click on upload button
    And   I click on confirm button
    And   I click on confirm_submission button
    Then  I see result file is submitted

  @rhcert_4x
  Scenario: Download Submitted Results to SUT
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on Download Button in the Submitted Test Results table
    Then  The Results File is downloaded

  @rhcert_5x
  Scenario: Test comments in Dialog tab
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on dialog tab
    And   I add "test comment for cloud" as a comment
    And   I click on Add Comment
    Then  I see comment "test comment for cloud" is added

  @rhcert_5x @rhcert_4x
  Scenario: Upload Attachment and Add Attachment Desciption in Dialog Tab
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on dialog tab
    And   I add an attachment
    And   I add description "Test Description" for the attachment
    And   I click on upload
    Then  I see attachment is successfully uploaded

  @rhcert_4x
  Scenario: Add Support Case ID to existing Certification
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on Details button
    And   I enter "01846543" Support Case ID
    And   I click on update button to update certification details
    Then  I can see the Certification details updated

  @rhcert_4x
  Scenario: Add KBase Reference ID to existing Certification
    Given I am logged into RHCERT
    When  I click "cloud" cert id
    And   I click on Details button
    And   I select "Red Hat Knowledge Base (Solution)" type
    And   I enter "3003271" KBase Reference ID
    And   I click on update button to update certification details
    Then  I can see the Certification details updated

  @rhcert_cli
  Scenario: Configure machine back to deafult
    Given  I have sshed into RHCERT
    When   I configure the machine to 'default'
    And    I verify machine is configured to 'dafault'
    Then   I close the RHCERT ssh connection
