Feature: Web UI Login Page

  @redhat_certification_ci @lts_only
  Scenario: Check for login button
    When   I go to the rhcert "login" page
    Then   I should see the "login button"
    And    I should see the "cancel button"

  @rhcert_4x
  Scenario: Login to Rhcert
    Given I go to RHCERT login page
    When  I fill in the rhcert login credential
    And   I click the Login button
    Then  I should be logged into RHCERT

  @rhcert_4x
  Scenario: Add a SUT to run the tests
    Given I am logged into RHCERT
    When  I go to the configuration tab
    And   I add a "hardware" SUT
    Then  The "hardware" SUT should be registered successfully

  @rhcert_4x
  Scenario: Refresh Button Functionality
    Given I am logged into RHCERT
    When  I check for Refresh Button
    Then  I can see the Refresh Button

@rhcert_4x @hardware_5x
  Scenario: Create hardware certification against a New Product on rhcert
    Given I am logged into RHCERT
    When  I click on the New Certification button
    When  I select product "Red Hat Enterprise Linux"
    And   I select RHEL version "7.4" for "hardware"
    And   I select platform "x86_64"
    And   I click on Next button
    And   I click on New Product
    And   I select vendor "Abbee (ID: 140)" for product creation
    And   I select Program "Red Hat Enterprise Linux Certified Hardware"
    And   I click on Next button
    And   I input "Certqe_jenkins" Make
    And   I input "Certqe_jenkins" Model
    And   I input "http://www.redhat.com" Product URL
    And   I click on Next button
    Then  I see the "hardware" product created on rhcert
    Then  I see the "hardware" certification created on rhcert against new Product
    And   I click on Details button
    And   I save the cert_nid of "hardware" created on rhcert

  @rhcert_4x
  Scenario: Select a SUT to run all mandatory hardware tests
    Given I have "hardware" "7.4" certification available on "x86_64" with make "All" for "Abbee (140)" "hardware: test_aditi_11april (3380913)"
    When  I click on Testing tab
    And   I click on Add System button
    And   I check for override button
    And   I select the radio button for "hardware" SUT
    And   I click on Test button
    And   I wait for a while for test verification
    And   I click on the Continue Testing button
    And   I click on the Run Selected Button
    And   I wait for a while for the "hardware" tests to run
    And   I click the "hardware" result link
    And   I submit the result
    Then  I can see the "hardware" result is submitted

@rhcert_4x
  Scenario: Create cert against existing product
    Given I am logged into RHCERT
    When  I click on the New Certification button
    When  I select product "Red Hat Enterprise Linux"
    And   I select RHEL version "7.4" for "hardware"
    And   I select platform "x86_64"
    And   I click on Next button
    And   I select vendor "Abbee (140)"
    And   I select Make "All"
    And   I select Name "hardware: test_aditi_11april (3380913)"
    And   I click on Next button
    Then  I see the "hardware" certification created on rhcert

  @hardware_5x
  Scenario: Testing Page Validation
    Given I am logged into RHCERT
    When  I click "hardware" cert id
    And   I validate the elements of this page
    Then  The testing page is validated

@rhcert_4x
  Scenario: Upload result for existing certification
    Given I am logged into RHCERT
    When  I click "hardware" cert id
    And   I click on upload result button
    And   I enter result file for uploading
    And   I click on upload button
    And   I click on confirm button
    And   I click on confirm_submission button
    Then  I see result file is submitted
    And   I click on Dialog tab
    And   I check result is submited sucessfully

@rhcert_5x
  Scenario: Test comments in Dialog tab
    Given I am logged into RHCERT
    When  I click "hardware" cert id
    And   I click on dialog tab
    And   I add "Test comment for Hardware Certification" as a comment
    And   I click on Add Comment
    Then  I see comment "Test comment for Hardware Certification" is added

@rhcert_5x @rhcert_4x
  Scenario: Upload Attachment and Add Attachment Desciption in Dialog Tab
    Given I am logged into RHCERT
    When  I click "hardware" cert id
    And   I click on dialog tab
    And   I add an attachment
    And   I add description "Test Description" for the attachment
    And   I click on upload
    Then  I see attachment is successfully uploaded
