try:
    import datetime
    from behave import when, then
    import utilities
    utilities.safe_selenium_imports(__file__, globals())
except ImportError as e:
    print("ImportError in {0}: {1}".format(__file__, e))
    raise e

# from selenium.webdriver.support.ui import Select

@when('I click on Cloud Certification')
def step_impl(context):
    element = '//*[@id="cp-content"]/div/div[2]/div[2]/ul/li[3]/a'
    context.browser.find_element_by_xpath(element).click()


@when('I fill all the mandatory details for cloud')
def step_impl(context):
    image_name = 'cloud_test'
    suffix = datetime.datetime.now().strftime("%y%m%d_%H%M%S")
    image_name = "_".join([image_name, suffix])
    image_version = context.browser.find_element_by_id('image_name')
    image_version.send_keys(image_name)
    context.browser.find_element_by_id(
        "readPolicy").click()
    submit_button = context.browser.find_element_by_xpath(
        "//button[@name='submit']")
    submit_button.click()


@given('I have an "{cert_type}" product available')
def step_impl(context, cert_type):

    context.execute_steps(u"""
                          When  I click on Add Products
                          When  I select the "{certification_type}" radio button
                          And   I click on Next
                          And   I search for "{certification_type}" product
                          And   I select a product from the list
                          And   I click on Add Selected Products
                          """.format(certification_type=cert_type))


@given('I am on the test plan for the created "{cert_type}" certification')
def step_impl(context, cert_type):
    context.execute_steps(u"""
                          given I have "{certification_type}" product available
                          When  I click on a "{certification_type}" certification
                          """.format(certification_type=cert_type))
