try:
    import xpath
    from behave import given, when, then
    import time
    import datetime
    import select
    from selenium.webdriver.support.select import Select
    from selenium import webdriver
except ImportError as e:
    print("ImportError in {0}: {1}".format(__file__, e))
    raise e

vname = 'vendor_' + str(datetime.datetime.now())
pname = vname + '_product'


def wait_fun(context, xpath_ele):
    webdriver.support.ui.WebDriverWait(context.browser, 60).until(webdriver.support.expected_conditions.presence_of_element_located((webdriver.common.by.By.XPATH, xpath_ele))).click()


@given('I am logging in to "{portal_env}" Customer Portal')
def create_vendor(context, portal_env):
    if portal_env == "qa":
        context.browser.get(context.data['common']['portal_vendor_qa']['uri'])
    else:
        context.browser.get(context.data['common']['portal_vendor_stage']['uri'])


@when('I click on User icon')
def create_vendor(context):
    wait_fun(context, xpath.cwe_user_icon)


@when('I click on Login button with existing username')
def create_vendor(context):
    wait_fun(context, xpath.cwe_account_login)


@when('I enter the user credentials')
def create_vendor(context):
    context.browser.find_element_by_xpath(xpath.cwe_username).send_keys(
        context.data['common']['portal_qa']['cp_username'])

    context.browser.find_element_by_xpath(xpath.cwe_password).send_keys(
        context.data['common']['portal_qa']['cp_password'])


@when('I submit the credentials')
def create_vendor(context):
    wait_fun(context, xpath.cwe_login_button)


@when('I click on Create vendor button')
def create_vendor(context):
    wait_fun(context, xpath.cwe_create_vendor_button)


@when('I enter the vendor name')
def create_vendor(context):
    context.browser.find_element_by_xpath(xpath.cwe_vendor_name).send_keys(vname)


@when('I select the "{vendor_type}" as group access')
def create_vendor(context, vendor_type):
    wait_fun(context, xpath.cwe_vendor_group)

    if vendor_type == 'Certified Cloud Providers':
        wait_fun(context, xpath.cwe_select_cloud)


    elif vendor_type == 'Certified Software':
        wait_fun(context, xpath.cwe_select_osp)


    elif vendor_type == 'Certified Hardware':
        wait_fun(context, xpath.cwe_select_hardware)


@when('I save the vendor information')
def create_vendor(context):
    wait_fun(context, xpath.cwe_save_vendor)


@then('I should be able to see the message of successfully creation of vendor')
def create_vendor(context):
    if context.browser.find_element_by_xpath(xpath.cwe_vendor_creation_message):
        pass


@when('I enter the vendor name in the search box')
def add_user(context):
    context.browser.find_element_by_xpath(xpath.cwe_vendor_name).send_keys(vname)


@when('I click on apply button')
def add_user(context):
    wait_fun(context, xpath.cwe_search_vendor_name)


@when('I click on the vendor name')
def add_user(context):
    context.browser.find_element_by_partial_link_text(vname).click()


@when('I click on the User & Permissions tab')
def add_user(context):
    wait_fun(context, xpath.cwe_add_user)


@when('I enter the "{adding_user}" as a certification user')
def add_user(context, adding_user):
    context.browser.find_element_by_xpath(xpath.cwe_add_ssouser).send_keys(adding_user)


@then('I click on Save Changes button')
def add_user(context):
    wait_fun(context, xpath.cwe_save_ssouser)


@when('I click on the Cloud Services tab')
def create_product(context):
    wait_fun(context, xpath.cwe_cloud_services)


@when('I click on Add new service button')
def create_product(context):
    wait_fun(context, xpath.cwe_add_new_service)


@when('I enter the product name')
def create_product(context):
    context.browser.find_element_by_xpath(xpath.cwe_vendor_name).send_keys(pname)


@when('I save the new product')
def create_product(context):
    wait_fun(context, xpath.cwe_save_vendor)


@then('I should be able to see the message of successfully creation of product')
def create_product(context):
    if context.browser.find_element_by_xpath(xpath.cwe_vendor_creation_message):
        pass


@when('I select newly created vendor')
def create_cert(context):
    select_ven = context.browser.find_element_by_id('vendor_id')

    for vendor in select_ven.find_elements_by_tag_name('option'):
        if vname in vendor.text:
            vendor.click()
            break


@when('I select newly created Product Name')
def create_cert(context):
    select_prod = context.browser.find_element_by_id('vendor_id')

    for product in select_prod.find_elements_by_tag_name('option'):
        if vname in product.text:
            product.click()
            break


@when('I click on the Software Products tab')
def create_product(context):
    context.browser.find_element_by_xpath(xpath.cwe_softwares_products).click()


@when('I click on Add new Software Product button')
def create_product(context):
    context.browser.find_element_by_xpath(xpath.cwe_add_new_software).click()


@when('I enter "{url}" as product url')
def create_product(context, url):
    context.browser.find_element_by_xpath(xpath.cwe_product_url).send_keys(url)


@when('I click on Features and Benefits tab')
def create_product(context):
    context.browser.find_element_by_xpath(xpath.cwe_features_benefits).click()


@when('I select all the subcategories')
def create_product(context):
    for i in range(0, 24):
        context.browser.find_element_by_xpath(xpath.cwe_subcategories).click()
        a = str(i)
        context.browser.find_element_by_xpath("//*[@data-option-array-index=" + a + "]").click()