#
# Copyright 2018 Red Hat Inc.
# Author: Vikas Mulaje <vmulaje@redhat.com>
# Co-Author: Aditi Puntambekar <apuntamb@redhat.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.  See
# http://www.gnu.org/copyleft/gpl.html for the full text of the
# license

try:
    import os
    import urllib2
    import shutil
    import time
    from behave import given, when, then
    import xpath
    import utilities
    utilities.safe_selenium_imports(__file__, globals())
except ImportError as e:
    print("ImportError in {0}: {1}".format(__file__, e))
    raise e

# from selenium.webdriver.common.by import By
# from selenium.webdriver.support import expected_conditions as EC
# from selenium.webdriver.support.ui import WebDriverWait

outputdir = "/tmp/result_repo/"

@step('I search for  "{nid}" cert_nid')
def step_impl(context, nid):
    time.sleep(10)
    search = context.browser.find_element_by_css_selector("input[type=\"search\"]")
    search.clear()
    search.send_keys(nid)
    search_link = context.browser.find_element_by_partial_link_text("Red Hat")
    search_link.click()

@when('I enter "{result_file}" for uploading')
def step_impl(context, result_file):
    context.browser.find_element_by_xpath("//input[@id='results-file']").send_keys(result_file)

@when('I click on upload result button')
def step_impl(context):
    context.browser.find_element_by_xpath("//a[contains(.,'Upload Results File')]").click()

@when('I enter result file for uploading')
def step_impl(context):
    if os.path.isdir(outputdir) == False:
        os.mkdir(outputdir)
    response = urllib2.urlopen(context.data['common']['logpath'])
    with open(context.data['common']['resultpath'], 'w') as dl:
        dl.write(response.read())
    context.browser.find_element_by_xpath("//input[@id='results-file']").send_keys(context.data['common']['resultpath'])

@when('I click on upload button')
def step_impl(context):
    context.browser.find_element_by_xpath("//button[@id='upload-btn']").click()

@when('I click on confirm button')
def step_impl(context):
    webdriver.support.ui.WebDriverWait(context.browser, 1000).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH,"//button[contains(.,'Confirm Upload')]")))
    context.browser.find_element_by_xpath("//button[contains(.,'Confirm Upload')]").click()

@when('I click on confirm_submission button')
def step_impl(context):
    webdriver.support.ui.WebDriverWait(context.browser, 1000).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH,"//button[contains(.,'Confirm Submission')]")))
    context.browser.find_element_by_xpath("//button[contains(.,'Confirm Submission')]").click()

@then('I see result file is submitted')
def step_impl(context):
    if os.path.isdir(outputdir) == True:
        shutil.rmtree(outputdir)
    webdriver.support.ui.WebDriverWait(context.browser, 1000).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH,"//a[contains(.,'Dialog')]")))


@then('I check result is submited sucessfully')
def step_impl(context):
    if 'completed' in context.browser.find_element_by_xpath(xpath.result_verification).text.split():
        print("Result submitted sucessfully")
    elif 'Submitted' in context.browser.find_element_by_xpath(xpath.result_verification).text.split():
        print("Result submitted sucessfully")
    else:
        assert True==False
