try:
    import time
    import os
    import paramiko
    import xpath
    from behave import given, when, then
    import utilities
    utilities.safe_selenium_imports(__file__, globals())
except ImportError as e:
    print("ImportError in {0}: {1}".format(__file__, e))
    raise e

    # from selenium.webdriver.common.by import By
    # from selenium.webdriver.support import expected_conditions as EC
    # from selenium.webdriver.support.ui import WebDriverWait, Select

neutron_feature_tests={
                    'neutron_address_scope':"//input[@value='openstack/neutron_address_scope']",
                    'neutron_agents':"//input[@value='openstack/neutron_agents']",
                    'neutron_attribute_extensions':"//input[@value='openstack/neutron_attribute_extensions']",
                    'neutron_availability_zone':"//input[@value='openstack/neutron_availability_zone']",
                    'neutron_dhcp_extra':"//input[@value='openstack/neutron_dhcp_extra']",
                    'neutron_flavor':"//input[@value='openstack/neutron_flavor']",
                    'neutron_gateway_extra':"//input[@value='openstack/neutron_gateway_extra']"
                    ,'neutron_gman':"//input[@value='openstack/neutron_gman']",
                    'neutron_ip_availability':"//input[@value='openstack/neutron_ip_availability']",
                    'neutron_ipv4':"//input[@value='openstack/neutron_ipv4']",
                    'neutron_ipv6':"//input[@value='openstack/neutron_ipv6']",
                    'neutron_l2_multi_provider':"//input[@value='openstack/neutron_l2_multi_provider']",
                    'neutron_l3_extra_route':"//input[@value='openstack/neutron_l3_extra_route']",
                    'neutron_l3_flavors':"//input[@value='openstack/neutron_l3_flavors']",
                    'neutron_l3_ha':"//input[@value='openstack/neutron_l3_ha']",
                    'neutron_lbaasv2':"//input[@value='openstack/neutron_lbaasv2']"
                    ,'neutron_metering':"//input[@value='openstack/neutron_metering']",
                    'neutron_mtu':"//input[@value='openstack/neutron_mtu']",
                    'neutron_qos':"//input[@value='openstack/neutron_qos']",
                    'neutron_rbac':"//input[@value='openstack/neutron_rbac']",
                    'neutron_security_groups':"//input[@value='openstack/neutron_security_groups']",
                    'neutron_service_types':"//input[@value='openstack/neutron_service_types']",
                    'neutron_subnet_allocation':"//input[@value='openstack/neutron_subnet_allocation']",
                    'neutron_subnet_default_pool':"//input[@value='openstack/neutron_subnet_default_pool']",
                    'neutron_tags':"//input[@value='openstack/neutron_tags']",
                    'neutron_trunk':"//input[@value='openstack/neutron_trunk']"
            }

manila_feature_tests={
	                'manila_share_extend': "//input[@value='openstack/manila_share_extend']",
	                'manila_share_managed': "//input[@value='openstack/manila_share_managed']",
	                'manila_share_shrink': "//input[@value='openstack/manila_share_shrink']",
	                'manila_shares': "//input[@value='openstack/manila_shares']",
	                'manila_snapshot_managed': "//input[@value='openstack/manila_snapshot_managed']",
	                'manila_snapshot_mountable': "//input[@value='openstack/manila_snapshot_mountable']",
	                'manila_snapshot_revert_to_snapshot': "//input[@value='openstack/manila_snapshot_revert_to_snapshot']",
	                'manila_snapshot_share_from_snapshot': "//input[@value='openstack/manila_snapshot_share_from_snapshot']",
	                'manila_snapshots': "//input[@value='openstack/manila_snapshots']"
                       }

cinder_feature_tests={
	                'cinder_consistency_groups': "//input[@value='openstack/cinder_consistency_groups']",
	                'cinder_volumes': "//input[@value='openstack/cinder_volumes']",
                        'cinder_backup':"//input[@value='openstack/cinder_backups']"
                        }

ironic_tests={
              'Ironic/supportable':"//input[contains(@value,'Ironic/supportable')]",
              'Ironic/Ironic':"//input[contains(@value,'Ironic/Ironic')]"
            }

driver_list={
             'pxe_ucs':"//option[@value='pxe_ucs']",
             'pxe_imrc':"//option[@value='pxe_irmc']",
             'pxe_drac':"//option[@value='pxe_drac']",
             'pxe_ilo':"//option[@value='pxe_ilo']",
             'pxe_impitool':"//option[@value='pxe_ipmitool']"
             }

director_test={
        'director':"//input[@value='openstack/director']"
        }

@when('I enter product version "{rhosp_version}"')
def step_impl(context,rhosp_version):
    product_version = context.browser.find_element_by_name("vendor_product_version")
    product_version.send_keys(rhosp_version)

@when('I click on Add Test System')
def step_impl(context):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH, "//a[contains(.,'Add Test System')]")))
    add_system=context.browser.find_element_by_xpath("//a[contains(.,'Add Test System')]")
    add_system.click()

@when('I select Certification "{rhel_cert}"')
def step_impl(context, rhel_cert):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH,"//button[contains(.,'Create')]")))
    certification_dropdown=context.browser.find_element_by_xpath("html/body/div[5]/form/div[2]/fieldset/div[1]/div/div/button")
    certification_dropdown.click()
    certs=context.browser.find_elements_by_xpath("//span[@class='text']")
    for cer in certs:
        cert_rhel = cer.text
        if cert_rhel == rhel_cert:
            cer.click()
            break

@when('I select Format of Red Hat OpenStack Platform Layered Product "{layered_cert}"')
def step_impl(context,layered_cert):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH,"//button[contains(.,'Create')]")))
    layered_cert_dropdown=context.browser.find_element_by_xpath("html/body/div[5]/form/div[2]/fieldset/div[2]/div/div/button")
    layered_cert_dropdown.click()
    lcerts=context.browser.find_elements_by_xpath("//span[@class='text']")
    for lcer in lcerts:
        cert_layered=lcer.text
        if cert_layered == layered_cert:
            lcer.click()
            break

@when('I see the Ironic certification created on rhcert')
def step_impl(context):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH, "//a[contains(.,'Testing')]")))

@when('I select the SUT "{cert_type}"')
def step_impl(context,cert_type):
    sut_host = context.data[context.data['parents'][cert_type]][cert_type]['sut']['host']
    context.browser.find_element_by_xpath(".//*[contains(text(),'"+sut_host+"')]/preceding::input[@type='radio']").click()


'''@when('I click on test button')
def step_impl(context):
    add_to_test=context.browser.find_element_by_xpath("//button[@value='Test']")
    add_to_test.click()
'''
@when('I click on continue testing')
def step_impl(context):
    #wait for installing packages
    webdriver.support.ui.WebDriverWait(context.browser, 800).until(
        webdriver.support.expected_conditions.presence_of_element_located((webdriver.common.by.By.NAME, "continue")))
    #finished test continue
    context.browser.find_element_by_xpath("//button[@name='continue']").click()

@when('I select feature tests for "{feature_test}"')
def step_impl(context,feature_test):
    if feature_test=="tempest_config":
        context.browser.find_element_by_xpath("//input[@value='openstack/tempest_config']").click()
    if feature_test=="neutron-all": #selecting all features of neutron
        for i in neutron_feature_tests:
           context.browser.find_element_by_xpath(neutron_feature_tests[i]).click()
    elif feature_test in neutron_feature_tests.keys(): #selecting specific feature of neutron
        context.browser.find_element_by_xpath(neutron_feature_tests[feature_test]).click()
    elif feature_test=="manila_all": #selecting all features of manila
        for i in manila_feature_tests:
           context.browser.find_element_by_xpath(manila_feature_tests[i]).click()
    elif feature_test in manila_feature_tests.keys():#selecting specific feature of manila
        context.browser.find_element_by_xpath(manila_feature_tests[feature_test]).click()
    elif feature_test=="cinder_all": #selecting all features of cinder
        for i in cinder_feature_tests:
           context.browser.find_element_by_xpath(cinder_feature_tests[i]).click()
    elif feature_test in cinder_feature_tests.keys():#selecting specific feature of cinder
        context.browser.find_element_by_xpath(cinder_feature_tests[feature_test]).click()
    elif feature_test=="ironic_all": #selecting all features of ironic
        for i in ironic_tests:
           context.browser.find_element_by_xpath(ironic_tests[i]).click()
    elif feature_test in ironic_tests.keys():#selecting specific feature of ironic
        context.browser.find_element_by_xpath(ironic_tests[feature_test]).click()
    elif feature_test in director_test.keys():
        context.browser.find_element_by_xpath(director_test[feature_test]).click()

@when('I enter a reason for need of packages to run supportable test "{reason}"')
def step_imp(context,reason):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH,"//input[@name='prompt-answer']")))
    reason1=context.browser.find_element_by_xpath("//input[@name='prompt-answer']")
    reason1.send_keys(reason)

@when('I select the Baremetal driver "{driver}"')
def step_imp(context,driver):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH,"//select[@name='prompt-answer']")))
    baremetal_driver_dropdown=context.browser.find_element_by_xpath("//select[@name='prompt-answer']")
    baremetal_driver_dropdown.click()
    drivers=context.browser.find_elements_by_xpath("//select[@name='prompt-answer']")
    for driver1 in drivers:
        driver_found=driver1.text
        if driver_found == driver:
            driver1.click()
            break

@when('I click on run test')
def step_impl(context):
    context.browser.find_element_by_xpath("//input[@value='Run Selected']").click()

@when('I wait for test run to complete')
def step_impl(context):
    if context.config.userdata["containers"]:

        containers_string=context.config.userdata["containers"]
        containers_list=containers_string.split(",")
        print(containers_list)
        #waiting for test run to complete
        webdriver.support.ui.WebDriverWait(context.browser, 1500).until(
              webdriver.support.expected_conditions.visibility_of_element_located((
                   webdriver.common.by.By.XPATH,xpath.osp_trusted_container_test_label)))


        for i in range(0,len(containers_list)):
            context.browser.find_element_by_xpath("//input[contains(@value,'"+containers_list[i]+"')]").click()
        context.browser.find_element_by_xpath(xpath.submit_button).click()

    try:
        webdriver.support.ui.WebDriverWait(context.browser, 8500).until(
        webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH,osp_prompt_answer)))
        text_box=context.browser.find_element_by_xpath(xpath.osp_prompt_answer)
        text_box.send_keys("yes")
        context.browser.find_element_by_xpath(xpath.submit_button).click()
        print("Supportable executed with user promt")
    except:
      pass
    webdriver.support.ui.WebDriverWait(context.browser, 180).until(
        webdriver.support.expected_conditions.visibility_of_element_located((
            webdriver.common.by.By.XPATH,xpath.osp_finished_test_run)))

@when('I click on "{plugin_name}" result link')
def step_impl(context,plugin_name):
    #cliicking on results generated
    context.browser.find_element_by_xpath(".//*[@id='"+context.data['network_and_storage'][plugin_name]['sut']['host']+"-results']/table/tbody/tr[1]/td[1]/a").click()

@when('I click on submit test')
def step_impl(context):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH,"//input[@name='submit']")))
    context.browser.find_element_by_xpath("//input[@name='submit']").click()

@when('I click on submit')
def step_impl(context):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH,"//h2[contains(.,'Submitting file:')]")))
    context.browser.find_element_by_xpath("//input[@type='submit']").click()

@then('I should see result is submitted')
def step_impl(context):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH, "//a[contains(.,'Dialog')]")))

@step('I click on dialog tab')
def step_impl(context):
    context.browser.find_element_by_xpath("//a[contains(.,'Dialog')]").click()
    time.sleep(15)

@when('I add attachment "{attachment}" and description "{description}"')
def step_impl(context,attachment,description):
    context.browser.find_element_by_xpath("//input[@id='chosenFile']").send_keys(attachment)
    time.sleep(5)
    context.browser.find_element_by_xpath("//input[@id='description']").send_keys(description)
    time.sleep(10)
@when('I click on upload')
def step_impl(context):
    context.browser.find_element_by_xpath("//button[@id='upload_attachment_button']").click()

@step('I see attachment uploaded')
def step_impl(context):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH, "//div[contains(@class,'toast-pf alert alert-success alert-dismissible')]")))

@when('I add "{comment}" as a comment')
def step_impl(context,comment):
    context.browser.find_element_by_xpath("//textarea[@id='newComment']").send_keys(comment)

@when('I click on Add comment')
def step_impl(context):
    context.browser.find_element_by_xpath("//button[contains(.,'Add comment')]").click()

@step('I see comment "{comment}" is added')
def step_impl(context,comment):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH, "//pre[contains(.,'"+comment+"')]")))

@when('I enter "{source_url}" as a source url')
def step_impl(context,source_url):
    context.data['source_url']=source_url
    context.browser.find_element_by_xpath("//input[@name='source_url']").clear()
    context.browser.find_element_by_xpath("//input[@name='source_url']").send_keys(source_url)

@when('I enter "{blueprint_url}" as a blueprint url')
def step_impl(context,blueprint_url):
    context.data['blueprint_url']=blueprint_url
    context.browser.find_element_by_xpath("//input[@name='blueprint_url']").clear()
    context.browser.find_element_by_xpath("//input[@name='blueprint_url']").send_keys(blueprint_url)

@when('I enter "{install_guide}" as a install guide')
def step_impl(context,install_guide):
    context.data['install_guide']=install_guide
    context.browser.find_element_by_xpath("//input[@name='install_guide']").clear()
    context.browser.find_element_by_xpath("//input[@name='install_guide']").send_keys(install_guide)

@when('I enter "{user_guide}" as a user guide')
def step_impl(context,user_guide):
    context.data['user_guide']=user_guide
    context.browser.find_element_by_xpath("//input[@name='user_guide']").clear()
    context.browser.find_element_by_xpath("//input[@name='user_guide']").send_keys(user_guide)

@when('I enter "{configuration}" as a configuration')
def step_impl(context,configuration):
    context.data['configuration']=configuration
    context.browser.find_element_by_xpath("//input[@name='configuration']").clear()
    context.browser.find_element_by_xpath("//input[@name='configuration']").send_keys(configuration)

@when('I enter "{hostname}" as a hostname')
def step_impl(context,hostname):
    context.data['hostname']=hostname
    context.browser.find_element_by_xpath("//input[@name='hostname']").clear()
    context.browser.find_element_by_xpath("//input[@name='hostname']").send_keys(hostname)

@when('I enter "{supported_languages}" in supported languages')
def step_impl(context,supported_languages):
#    context.browser.find_element_by_xpath("//input[@name='supported_languages']").clear
#    context.browser.find_element_by_xpath("//input[@name='supported_languages']").send_keys(supported_languages)
     context.browser.find_element_by_id('supported_languages').clear()
     context.browser.find_element_by_id('supported_languages').send_keys(supported_languages)

@when('I enter "{third_party_certifications}" in 3rd Party Certifications')
def step_impl(context,third_party_certifications):
#    context.browser.find_element_by_xpath("//input[@name='third_party_certifications']").clear
#    context.browser.find_element_by_xpath("//input[@name='third_party_certifications']").send_keys(third_party_certifications)
     context.browser.find_element_by_id('third_party_certifications').clear
     context.browser.find_element_by_id('third_party_certifications').send_keys(third_party_certifications)

@step('I validate the data which I have entered while cert creation')
def step_impl(context):
    for table_index in range(1,50):
        if context.browser.find_element_by_xpath("id('DataTables_Table_0')/tbody[2]/tr["+str(table_index)+"]/td[1]").text=="blueprint_url":
            b_url=str(table_index)
        elif context.browser.find_element_by_xpath("id('DataTables_Table_0')/tbody[2]/tr["+str(table_index)+"]/td[1]").text=="configuration":
            conf=str(table_index)
        elif context.browser.find_element_by_xpath("id('DataTables_Table_0')/tbody[2]/tr["+str(table_index)+"]/td[1]").text=="hostname":
            h_name=str(table_index)
        elif context.browser.find_element_by_xpath("id('DataTables_Table_0')/tbody[2]/tr["+str(table_index)+"]/td[1]").text=="install_guide":
            i_guide=str(table_index)
        elif context.browser.find_element_by_xpath("id('DataTables_Table_0')/tbody[2]/tr["+str(table_index)+"]/td[1]").text=="source_url":
            s_url=str(table_index)
        elif context.browser.find_element_by_xpath("id('DataTables_Table_0')/tbody[2]/tr["+str(table_index)+"]/td[1]").text=="user_guide":
            u_guide=str(table_index)
            break
    assert context.data['hostname']==context.browser.find_element_by_xpath("id('DataTables_Table_0')/tbody[2]/tr["+h_name+"]/td[2]").text
    assert context.data['configuration']==context.browser.find_element_by_xpath("id('DataTables_Table_0')/tbody[2]/tr["+conf+"]/td[2]").text
    assert context.data['user_guide']==context.browser.find_element_by_xpath("id('DataTables_Table_0')/tbody[2]/tr["+u_guide+"]/td[2]").text
    assert context.data['install_guide']==context.browser.find_element_by_xpath("id('DataTables_Table_0')/tbody[2]/tr["+i_guide+"]/td[2]").text
    assert context.data['blueprint_url']==context.browser.find_element_by_xpath("id('DataTables_Table_0')/tbody[2]/tr["+b_url+"]/td[2]").text
    assert context.data['source_url']==context.browser.find_element_by_xpath("id('DataTables_Table_0')/tbody[2]/tr["+s_url+"]/td[2]").text

"""Updating cert details in Product/Product Details tab"""
@when('I click on Product tab')
def step_impl(context):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH, "//a[contains(.,'Product')]")))
    context.browser.find_element_by_xpath("//a[contains(.,'Product')]").click()

@when('I click on Product Details tab')
def step_impl(context):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH, "//a[contains(.,'Product Details')]")))
    context.browser.find_element_by_xpath("//a[contains(.,'Product Details')]").click()

@when('I click on update button')
def step_impl(context):
    context.browser.find_element_by_xpath("//button[@value='update']").click()

@then('I can see details updated')
def step_impl(context):
    webdriver.support.ui.WebDriverWait(context.browser, 500).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH, "//div[contains(@class,'toast-pf alert alert-success alert-dismissible')]")))

def get_tempest_details(context):
    password=context.config.userdata["password"]
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    ssh.load_host_keys(os.path.expanduser(os.path.join("~", ".ssh", "known_hosts")))
    ssh.connect(context.data['common']['rhcert']['ip'], username='root', password=password)
    try:
    	stdin,stdout,stderr = ssh.exec_command("ssh stack@undercloud-0 cat overcloudrc")
    	overcloudrc=stdout.readlines()
    except:
    	print("Error reading Overcloudrc file")
    for line in overcloudrc:
       if 'OS_PROJECT_NAME' in line:
            tenant=line.split('=')[1][:-1]
       elif 'OS_USERNAME' in line:
           user=line.split('=')[1][:-1]
       elif 'OS_PASSWORD' in line:
           password=line.split('=')[1][:-1]
       elif 'OS_AUTH_URL' in line:
           url=line.split('=')[1][:-1]

    ssh.close()

    return url,user,password,tenant

@when('Fill details for tempest config')
def step_impl(context):
    details=get_tempest_details(context)
    webdriver.support.ui.WebDriverWait(context.browser, 50).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH, \
     "//label[contains(.,'Please input your keystone auth url (eg: http://your_openstack:5000/v2.0): ')]")))
    context.browser.find_element_by_xpath("//input[@id='prompt-answer']").clear()
    context.browser.find_element_by_xpath("//input[@id='prompt-answer']").send_keys(details[0])
    context.browser.find_element_by_xpath("//input[@value='Submit']").click()
    webdriver.support.ui.WebDriverWait(context.browser, 50).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH, \
                      "//label[contains(.,'Enter OpenStack admin username: ')]")))
    context.browser.find_element_by_xpath("//input[@id='prompt-answer']").clear()
    context.browser.find_element_by_xpath("//input[@id='prompt-answer']").send_keys(details[1])
    context.browser.find_element_by_xpath("//input[@value='Submit']").click()
    webdriver.support.ui.WebDriverWait(context.browser, 50).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH, \
                    "//label[contains(.,'Enter OpenStack admin password: ')]")))
    context.browser.find_element_by_xpath("//input[@id='prompt-answer']").clear()
    context.browser.find_element_by_xpath("//input[@id='prompt-answer']").send_keys(details[2])
    context.browser.find_element_by_xpath("//input[@value='Submit']").click()
    webdriver.support.ui.WebDriverWait(context.browser, 50).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH, \
                    "//label[contains(.,'Enter OpenStack admin tenant name: ')]")))
    context.browser.find_element_by_xpath("//input[@id='prompt-answer']").clear()
    context.browser.find_element_by_xpath("//input[@id='prompt-answer']").send_keys(details[3])
    context.browser.find_element_by_xpath("//input[@value='Submit']").click()
    time.sleep(15)
    context.browser.find_element_by_xpath("//input[@value='Submit']").click()

@when('I select save option')
def step_impl(context):
    context.browser.find_element_by_xpath("//option[@value='/save']").click()

@when('I enter LTS name for result saving')
def step_impl(context):
    context.browser.find_element_by_xpath("//input[@name='server']").send_keys(context.data['common']['rhcert']['ip'])

@when('I click on save button')
def step_impl(context):
    context.browser.find_element_by_xpath("//input[@type='submit']").click()

@when('I click on save button on product details page')
def step_impl(context):
     context.browser.find_element_by_xpath("//button[@value='update']").click()

@then('I should see result saved')
def step_impl(context):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(webdriver.support.expected_conditions.visibility_of_element_located((webdriver.common.by.By.XPATH,"//h2[contains(.,'Save Test Results')]")))
@when('I enter "{option}" for apps on rhel')
def step_impl(context,option):
    if option=="yes":
        context.browser.find_element_by_xpath("//input[@id='app_on_rhel_yes']").click()
    elif option=="no":
        context.browser.find_element_by_xpath("//input[@id='app_on_rhel_no']").click()

@when('I enter "{option}" for apps on RHOSP')
def step_impl(context,option):
    if option=="yes":
        context.browser.find_element_by_xpath("//input[@id='app_on_openstack_yes']").click()
    elif option=="no":
        context.browser.find_element_by_xpath("//input[@id='app_on_openstack_no']").click()

@when('I enter "{option}" for additional kernel drivers')
def step_impl(context,option):
    if option=="yes":
        context.browser.find_element_by_xpath("//input[@id='ship_hardware_yes']").click()
    elif option=="no":
        context.browser.find_element_by_xpath("//input[@id='ship_hardware_no']").click()

@when('I enter "{hardware}" for special hardware requirement')
def step_impl(context,hardware):
    context.browser.find_element_by_xpath("//textarea[@name='solution_dependancy']").send_keys(hardware)

@given('I logged into the SUT for "{plugin}" log validation')
def step_impl(context,plugin):
    password=context.config.userdata["password"]
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    ssh.load_host_keys(os.path.expanduser(os.path.join("~", ".ssh", "known_hosts")))
    rhcert_ip=context.data['common']['rhcert']['ip']
    sut_ip=context.data['network_and_storage'][plugin]['sut']['host']
    ssh.connect(rhcert_ip, username='root', password=password)
    stdin,stdout,stderr = ssh.exec_command("ssh stack@undercloud-0 ssh heat-admin@"+str(sut_ip)+" sudo yum install -y wget")

@when('I wget the script for "{plugin}"')
def step_impl(context,plugin):
    password=context.config.userdata["password"]
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    ssh.load_host_keys(os.path.expanduser(os.path.join("~", ".ssh", "known_hosts")))
    rhcert_ip=context.data['common']['rhcert']['ip']
    sut_ip=context.data['network_and_storage'][plugin]['sut']['host']
    ssh.connect(rhcert_ip, username='root', password=password)
    stdin,stdout,stderr = ssh.exec_command("ssh stack@undercloud-0 ssh heat-admin@"+str(sut_ip)+" sudo wget http://file.pnq.redhat.com/atandale/logs_validate/"+str(plugin)+".py")

@then('I validate the logs for "{plugin}"')
def step_impl(context,plugin):
    password=context.config.userdata["password"]
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    ssh.load_host_keys(os.path.expanduser(os.path.join("~", ".ssh", "known_hosts")))
    rhcert_ip=context.data['common']['rhcert']['ip']
    sut_ip=context.data['network_and_storage'][plugin]['sut']['host']
    ssh.connect(rhcert_ip, username='root', password=password)
    stdin,stdout,stderr = ssh.exec_command("ssh stack@undercloud-0 ssh heat-admin@"+str(sut_ip)+" sudo python "+str(plugin)+".py")

@when('I wget the log validation script for ccsp')
def step_impl(context):
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    ssh.load_host_keys(os.path.expanduser(os.path.join("~", ".ssh", "known_hosts")))
    cmd = "wget http://file.pnq.redhat.com/sgangawa/ccsp_log_validation/log_validation.py"
    stdin,stdout,stderr = context.cloud_ssh.exec_command(cmd)

@then('I validate the logs for ccsp')
def step_impl(context):
    ssh = paramiko.SSHClient()
    ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
    ssh.load_host_keys(os.path.expanduser(os.path.join("~", ".ssh", "known_hosts")))
    cmd = "python log_validation.py"
    stdin,stdout,stderr = context.cloud_ssh.exec_command(cmd)

@given('I am logged in to "{portal_env}" Customer Portal')
def step_impl(context, portal_env):
    if portal_env == "qa":
        context.browser.get(context.data['common']['portal_qa']['uri'])
        portal_username = context.browser.find_element_by_id('username')
        portal_password = context.browser.find_element_by_id('password')
        portal_username.send_keys(context.data['common']['portal_qa']['cp_username'])
        portal_password.send_keys(context.data['common']['portal_qa']['cp_password'])

    else:
        context.browser.get(context.data['common']['portal_stage']['uri'])
        portal_username = context.browser.find_element_by_id('username')
        portal_password = context.browser.find_element_by_id('password')
        portal_username.send_keys(context.data['common']['portal_stage']['cp_username'])
        portal_password.send_keys(context.data['common']['portal_stage']['cp_password'])

    portal_login = context.browser.find_element_by_id('_eventId_submit')
    portal_login.click()

@when('I click on Cloud Services tab')
def step_impl(context):
    cloud_tab = "//a[contains(text(),'Cloud Services')]"
    context.browser.find_element_by_xpath(cloud_tab).click()

@when('I click on Add a New Cloud Service')
def step_impl(context):
    webdriver.support.ui.WebDriverWait(context.browser, 300).until(
            webdriver.support.expected_conditions.presence_of_element_located((
                webdriver.common.by.By.XPATH, "//a[contains(text(),'Add a new Cloud Service')]")))
    context.browser.find_element_by_xpath("//a[contains(text(),'Add a new Cloud Service')]").click()

@when('I enter Product name')
def step_impl(context):
    product_name = context.browser.find_element_by_id('edit-title')
    pname = "Test Image for Cloud - "
    pname1 = pname + time.strftime("%Y%m%d - %H%M%S")
    product_name.send_keys(pname1)

@when('I enter Product URL')
def step_impl(context):
    product_url = context.browser.find_element_by_id('edit-field-eco-product-url-str-und-0-value')
    product_url.send_keys("http://www.redhat.com")

@when('I click on save button on CP')
def step_impl(context):
    context.browser.find_element_by_xpath("//input[@id='edit-submit']").click()

@then('I should see "{cert_type}" Product created')
def step_impl(context, cert_type):
    url = context.browser.current_url
    product_id = url.split('/')[5]
    context.data[context.data['parents'][cert_type]][cert_type]['product_id_rhcert'] = product_id
    prod_name = context.browser.find_element_by_xpath("//h1[@id='page-title']")
    prod_name1 = prod_name.text
    context.data[context.data['parents'][cert_type]][cert_type]['product_name_rhcert'] = prod_name1

@when('I select Product name for "{cert_type}"')
def step_impl(context, cert_type):
    product_name_1 = webdriver.support.ui.Select(context.browser.find_element_by_name('vendor_product_id'))
    prod_name1 = context.data[context.data['parents'][cert_type]][cert_type]['product_name_rhcert']
    product_id = context.data[context.data['parents'][cert_type]][cert_type]['product_id_rhcert']
    select_product = "cloud: "+prod_name1+' ('+str(product_id)+')'
    product_name_1.select_by_visible_text(select_product)

