try:
    import time

    from behave import given, when, then
    import utilities
    utilities.safe_selenium_imports(__file__, globals())
except ImportError as e:
    print("ImportError in {0}: {1}".format(__file__, e))
    raise e




from behave import given, when, then
import xpath
@given('I am on CWE landing page')
def step_impl(context):
    context.browser.get(context.data['common']['cwe']['uri'])


@given('I am on QA CWE landing page')
def step_impl(context):
    context.browser.get("https://hwcert-web2-test.devel.redhat.com/redhat_login.cgi")

@given('I am on STAGE CWE landing page')
def step_impl(context):
    context.browser.get("https://partner-hwcert.redhat.com/redhat_login.cgi")

@when('I click on login icon')
def step_impl(context):
    user_icon = context.browser.find_element_by_class_name("web-icon-user")
    user_icon.click()


@when('I click on login button')
def step_impl(context):
    login = context.browser.find_element_by_xpath(xpath.cwe_login_button)
    login.click()

@when('I click on Administration')
def step_impl(context):
    webdriver.support.ui.WebDriverWait(context.browser, 8200).until(
    webdriver.support.expected_conditions.visibility_of_element_located(
    (webdriver.common.by.By.XPATH,xpath.cwe_administration)))
    context.browser.find_element_by_xpath(xpath.cwe_administration).click()

@when('I click on Rhcert Versions')
def step_impl(context):
    context.browser.find_element_by_xpath(xpath.cwe_rhcert_version).click()


@when('I click on Add Version')
def step_impl(context):
    context.browser.find_element_by_xpath(xpath.cwe_add).click()

@when('I Fill out details of rhcert "{RHCERT}"')
def step_impl(context,RHCERT):
    context.browser.find_element_by_xpath(xpath.cwe_version_box).send_keys(RHCERT)
    year = webdriver.support.ui.Select(context.browser.find_element_by_name('release_year'))
    year.select_by_visible_text(RHCERT.split('-')[3][0:4])
    month = webdriver.support.ui.Select(context.browser.find_element_by_name('release_month'))
    month.select_by_visible_text(str(int(RHCERT.split('-')[3][4:6])))
    day = webdriver.support.ui.Select(context.browser.find_element_by_name('release_day'))
    day.select_by_visible_text(str(int(RHCERT.split('-')[3][6:8])))


@when('I click on support checkbox')
def step_impl(context):
    context.browser.find_element_by_xpath(xpath.cwe_version_support).click()


@then('I click on save changes')
def step_impl(context):
    context.browser.find_element_by_xpath(xpath.cwe_save_changes).click()
    time.sleep(7)




@when('I fill in the cwe login credentials')
def step_impl(context):
    username = context.browser.find_element_by_id('username')
    password = context.browser.find_element_by_id('password')
    username.send_keys(context.data['common']['cwe']['sso_username'])
    password.send_keys(context.data['common']['cwe']['sso_password'])


@given('I am on CWE login page')
def step_impl(context):
    context.execute_steps(u"""
                          given I am on CWE landing page
                          when I click on login icon
                          and I click on login button
                         """)


@when('I click on Submit button')
def step_impl(context):
    context.browser.find_element_by_id('_eventId_submit').click()


@when('I click on profile dropdown while logged in')
def step_impl(context):
    context.browser.find_element_by_id(
        'accountUserName').click()


@then('I should see the logout button')
def step_impl(context):
    accountLogout = context.browser.find_element_by_id('accountLogout')
    assert accountLogout.get_attribute('innerHTML') == 'Log Out'


@when("I click on 'Review' tab")
def step_impl(context):
    context.browser.find_element_by_css_selector(
        "a[href='#review'][role='tab']").click()


@when('I should see Upload Results heading')
def step_impl(context):
    result = context.browser.find_element_by_id('upload-package-spec')
    assert result.get_attribute('innerHTML') == 'Upload Results Package'


@when('I select file to be uploaded')
def step_impl(context):
    file_upload = context.browser.find_element_by_css_selector("input[type=\"file\"]")
    file_upload.send_keys(context.data['common']['logpath'])


@when('I enter description of uploaded file')
def step_impl(context):
    description = context.browser.find_element_by_name('description')
    description.send_keys('file_attached')


@when('I click on ATTACH FILE button to upload logs')
def step_impl(context):
    attach_button = context.browser.find_element_by_css_selector(
        "input[type='submit'][value='Attach File']")
    attach_button.click()
